SET ANSI_NULLS ON
GO
SET QUOTED_IDENTIFIER ON
GO

USE [SyncDemoClientTwo]
GO

-- Key Generation
IF NOT EXISTS(SELECT [pk_row_id_local] FROM [dbo].[KeyGeneration]) BEGIN
	INSERT INTO [dbo].[KeyGeneration]
           ([pk_client] ,[pk_table_name],[pk_client_name],[pk_row_id_local])
     VALUES( 0          ,'dbo.FakeTable','Zero'           ,0)
	INSERT INTO [dbo].[KeyGeneration]
           ([pk_client] ,[pk_table_name],[pk_client_name],[pk_row_id_local])
     VALUES( 1          ,'dbo.FakeTable','One'           ,0)
END

GO

-- Anchor
IF NOT EXISTS(SELECT [anc_table] FROM [dbo].[Anchor]) BEGIN
	INSERT INTO [dbo].[Anchor]
           ([anc_table] ,[anc_sent],[anc_received],[anc_server_applied])
     VALUES
           ('dbo.FakeTable',NULL,NULL,NULL)
END

GO



-- Fake Data [notice there is no identity for this table]
DECLARE @NonGuidSafeID bigint
DECLARE @ClientID int

IF NOT EXISTS(SELECT [fkt_id] FROM [dbo].[FakeTable]) BEGIN
	SET @ClientID = 0
	
	EXEC [dbo].[spGenerateKey] @ClientID, 'dbo.FakeTable', @NonGuidSafeID output
	INSERT INTO [dbo].[FakeTable]([fkt_id],[fkt_name],[fkt_desc])
	VALUES (@NonGuidSafeID, 'Harry Potter', 'A movie about a kid who..')
	
	EXEC [dbo].[spGenerateKey] @ClientID, 'dbo.FakeTable', @NonGuidSafeID output
	INSERT INTO [dbo].[FakeTable]([fkt_id],[fkt_name],[fkt_desc])
	VALUES (@NonGuidSafeID, 'Tangled', 'A comedic take on the old..')
	
	EXEC [dbo].[spGenerateKey] @ClientID, 'dbo.FakeTable', @NonGuidSafeID output
	INSERT INTO [dbo].[FakeTable]([fkt_id],[fkt_name],[fkt_desc])
	VALUES (@NonGuidSafeID, 'Beauty and the Beast', 'The classic tale about a beautiful..')
	
	SET @ClientID = 1
	
	EXEC [dbo].[spGenerateKey] @ClientID, 'dbo.FakeTable', @NonGuidSafeID output
	INSERT INTO [dbo].[FakeTable]([fkt_id],[fkt_name],[fkt_desc])
	VALUES (@NonGuidSafeID, 'Insidious', 'A family moves into an old house after the birth..')

	EXEC [dbo].[spGenerateKey] @ClientID, 'dbo.FakeTable', @NonGuidSafeID output
	INSERT INTO [dbo].[FakeTable]([fkt_id],[fkt_name],[fkt_desc])
	VALUES (@NonGuidSafeID, 'Source Code', 'A soldier finds himself in the body ..')
	
	EXEC [dbo].[spGenerateKey] @ClientID, 'dbo.FakeTable', @NonGuidSafeID output
	INSERT INTO [dbo].[FakeTable]([fkt_id],[fkt_name],[fkt_desc])
	VALUES (@NonGuidSafeID, 'Madagascar ', 'A lion, a zebra, a hippopotamus and a giraffe..')

END
GO


