﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SQLChangeTrackingSync.UI;
using SQLChangeTrackingSync.Sample.Entities;
using SQLChangeTrackingSync.Sample;

namespace SQLChangeTrackingSync.UI
{
    public partial class PrimaryForm : Form
    {
        public PrimaryForm()
        {
            InitializeComponent();
        }

        private Guid _serverID = new Guid("{5EF84A36-679B-42d3-B180-871D89DE796F}"); // this should come from config somewhere
        private Guid _clientID = new Guid("{65096D67-957C-4A7F-90B7-4DA1237E87E4}"); // this should come from config somewhere
        private Guid _clientID2 = new Guid("{EBA97D9C-07E2-421b-A5E0-1AD357C8C429}"); // this should come from config somewhere
        private string _clientConnectionString = @"server=CODEABLE\SQLEXPRESS;initial catalog=SyncDemoClient;integrated security=SSPI"; // this should come from config somewhere
        private string _clientConnectionString2 = @"server=CODEABLE\SQLEXPRESS;initial catalog=SyncDemoClientTwo;integrated security=SSPI"; // this should come from config somewhere
        private string _serverConnectionString = @"server=CODEABLE\SQLEXPRESS;initial catalog=SyncDemoServer;integrated security=SSPI"; // this should come from config somewhere
        private List<SillyConfig> _tableConfiguration; // this should come from config somewhere, filled in GetSampleConfiguration()

        /// <summary>
        /// This should be replaced 
        /// </summary>
        private List<SillyConfig> GetSampleConfiguration()
        {
            if (_tableConfiguration == null)
            {
                List<SillyConfig> sillyConfigs = new List<SillyConfig>();

                SillyConfig config = new SillyConfig();
                config.creationOption = Microsoft.Synchronization.Data.TableCreationOption.UseExistingTableOrFail; // My personal recommendation, I prefer intimate control
                config.direction = Microsoft.Synchronization.Data.SyncDirection.Bidirectional;
                config.schema = "dbo";
                config.table = "FakeTable";
                sillyConfigs.Add(config);

                _tableConfiguration = sillyConfigs;
            }
            return _tableConfiguration;
        }

        private void DoSync()
        {
            try
            {
                // SyncUtility is just an easy way to generate these classes, it can easily be replaced/adjusted to fit your coding model
                // The only thing it has "hard coded" is the SyncUtility.ANCHOR_SCHEMA and SyncUtility.ANCHOR_TABLE
                SampleSyncAgent syncAgent = SyncUtility.CreateSyncAgent(_clientID, _serverID, _clientConnectionString, _serverConnectionString, GetSampleConfiguration());
                List<ConflictLog> conflicts = syncAgent.DoSynchronize();
                if (conflicts.Count == 0)
                {
                    MessageBox.Show("Sync Completed with no Conflicts", "DoSync", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    new SyncResultForm(conflicts).Show(this);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "DoSync", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        private void DoSync2()
        {
            try
            {
                // SyncUtility is just an easy way to generate these classes, it can easily be replaced/adjusted to fit your coding model
                // The only thing it has "hard coded" is the SyncUtility.ANCHOR_SCHEMA and SyncUtility.ANCHOR_TABLE
                SampleSyncAgent syncAgent = SyncUtility.CreateSyncAgent(_clientID2, _serverID, _clientConnectionString2, _serverConnectionString, GetSampleConfiguration());
                List<ConflictLog> conflicts = syncAgent.DoSynchronize();
                if (conflicts.Count == 0)
                {
                    MessageBox.Show("Sync Completed with no Conflicts", "DoSync", MessageBoxButtons.OK, MessageBoxIcon.Information);
                }
                else
                {
                    new SyncResultForm(conflicts).Show(this);
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "DoSync", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }

        private void btnSync_Click(object sender, EventArgs e)
        {
            this.DoSync();
        }

        private void btnSync2_Click(object sender, EventArgs e)
        {
            this.DoSync2();
        }
    }
}
