﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using SQLChangeTrackingSync.Sample.Entities;


namespace SQLChangeTrackingSync.UI
{
    public partial class SyncResultForm : Form
    {
        public SyncResultForm()
        {
            InitializeComponent();
        }
        public SyncResultForm(List<ConflictLog> conflicts)
            : this()
        {
            Initialize(conflicts);
        }

        public void Initialize(List<ConflictLog> conflicts)
        {
            try
            {
                conflictBindingSource.DataSource = conflicts;
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Initialize", MessageBoxButtons.OK, MessageBoxIcon.Error);
            }
        }
        

        private void conflictBindingSource_DataError(object sender, BindingManagerDataErrorEventArgs e)
        {
            MessageBox.Show(e.Exception.Message, "conflictBindingSource_DataError", MessageBoxButtons.OK, MessageBoxIcon.Error);
        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            this.Close();
        }
    }
}
